/*!
 * Scroller
 * http://github.com/zynga/scroller
 *
 * Copyright 2011, Zynga Inc.
 * Licensed under the MIT License.
 * https://raw.github.com/zynga/scroller/master/MIT-LICENSE.txt
 *
 * Based on the work of: Unify Project (unify-project.org)
 * http://unify-project.org
 * Copyright 2011, Deutsche Telekom AG
 * License: MIT + Apache (V2)
 */

var Scroller;(function(){var e=function(){};Scroller=function(t,n){this.__callback=t;this.options={scrollingX:true,scrollingY:true,animating:true,animationDuration:250,bouncing:true,locking:true,paging:false,snapping:false,zooming:false,minZoom:.5,maxZoom:3,speedMultiplier:1,scrollingComplete:e};for(var r in n){this.options[r]=n[r]}};var t=function(e){return Math.pow(e-1,3)+1};var n=function(e){if((e/=.5)<1){return.5*Math.pow(e,3)}return.5*(Math.pow(e-2,3)+2)};var r={__isSingleTouch:false,__isTracking:false,__didDecelerationComplete:false,__isGesturing:false,__isDragging:false,__isDecelerating:false,__isAnimating:false,__clientLeft:0,__clientTop:0,__clientWidth:0,__clientHeight:0,__contentWidth:0,__contentHeight:0,__snapWidth:100,__snapHeight:100,__refreshHeight:null,__refreshActive:false,__refreshActivate:null,__refreshDeactivate:null,__refreshStart:null,__zoomLevel:1,__scrollLeft:0,__scrollTop:0,__maxScrollLeft:0,__maxScrollTop:0,__scheduledLeft:0,__scheduledTop:0,__scheduledZoom:0,__lastTouchLeft:null,__lastTouchTop:null,__lastTouchMove:null,__positions:null,__minDecelerationScrollLeft:null,__minDecelerationScrollTop:null,__maxDecelerationScrollLeft:null,__maxDecelerationScrollTop:null,__decelerationVelocityX:null,__decelerationVelocityY:null,setDimensions:function(e,t,n,r){var i=this;if(e===+e){i.__clientWidth=e}if(t===+t){i.__clientHeight=t}if(n===+n){i.__contentWidth=n}if(r===+r){i.__contentHeight=r}i.__computeScrollMax();i.scrollTo(i.__scrollLeft,i.__scrollTop,true)},setPosition:function(e,t){var n=this;n.__clientLeft=e||0;n.__clientTop=t||0},setSnapSize:function(e,t){var n=this;n.__snapWidth=e;n.__snapHeight=t},activatePullToRefresh:function(e,t,n,r){var i=this;i.__refreshHeight=e;i.__refreshActivate=t;i.__refreshDeactivate=n;i.__refreshStart=r},finishPullToRefresh:function(){var e=this;e.__refreshActive=false;if(e.__refreshDeactivate){e.__refreshDeactivate()}e.scrollTo(e.__scrollLeft,e.__scrollTop,true)},getValues:function(){var e=this;return{left:e.__scrollLeft,top:e.__scrollTop,zoom:e.__zoomLevel}},getScrollMax:function(){var e=this;return{left:e.__maxScrollLeft,top:e.__maxScrollTop}},zoomTo:function(e,t,n,r){var i=this;if(!i.options.zooming){throw new Error("Zooming is not enabled!")}if(i.__isDecelerating){core.effect.Animate.stop(i.__isDecelerating);i.__isDecelerating=false}var s=i.__zoomLevel;if(n==null){n=i.__clientWidth/2}if(r==null){r=i.__clientHeight/2}e=Math.max(Math.min(e,i.options.maxZoom),i.options.minZoom);i.__computeScrollMax(e);var o=(n+i.__scrollLeft)*e/s-n;var u=(r+i.__scrollTop)*e/s-r;if(o>i.__maxScrollLeft){o=i.__maxScrollLeft}else if(o<0){o=0}if(u>i.__maxScrollTop){u=i.__maxScrollTop}else if(u<0){u=0}i.__publish(o,u,e,t)},zoomBy:function(e,t,n,r){var i=this;i.zoomTo(i.__zoomLevel*e,t,n,r)},scrollTo:function(e,t,n,r){var i=this;if(i.__isDecelerating){core.effect.Animate.stop(i.__isDecelerating);i.__isDecelerating=false}if(r!=null&&r!==i.__zoomLevel){if(!i.options.zooming){throw new Error("Zooming is not enabled!")}e*=r;t*=r;i.__computeScrollMax(r)}else{r=i.__zoomLevel}if(!i.options.scrollingX){e=i.__scrollLeft}else{if(i.options.paging){e=Math.round(e/i.__clientWidth)*i.__clientWidth}else if(i.options.snapping){e=Math.round(e/i.__snapWidth)*i.__snapWidth}}if(!i.options.scrollingY){t=i.__scrollTop}else{if(i.options.paging){t=Math.round(t/i.__clientHeight)*i.__clientHeight}else if(i.options.snapping){t=Math.round(t/i.__snapHeight)*i.__snapHeight}}e=Math.max(Math.min(i.__maxScrollLeft,e),0);t=Math.max(Math.min(i.__maxScrollTop,t),0);if(e===i.__scrollLeft&&t===i.__scrollTop){n=false}i.__publish(e,t,r,n)},scrollBy:function(e,t,n){var r=this;var i=r.__isAnimating?r.__scheduledLeft:r.__scrollLeft;var s=r.__isAnimating?r.__scheduledTop:r.__scrollTop;r.scrollTo(i+(e||0),s+(t||0),n)},doMouseZoom:function(e,t,n,r){var i=this;var s=e>0?.97:1.03;return i.zoomTo(i.__zoomLevel*s,false,n-i.__clientLeft,r-i.__clientTop)},doTouchStart:function(e,t){if(e.length==null){throw new Error("Invalid touch list: "+e)}if(t instanceof Date){t=t.valueOf()}if(typeof t!=="number"){throw new Error("Invalid timestamp value: "+t)}var n=this;n.__interruptedAnimation=true;if(n.__isDecelerating){core.effect.Animate.stop(n.__isDecelerating);n.__isDecelerating=false;n.__interruptedAnimation=true}if(n.__isAnimating){core.effect.Animate.stop(n.__isAnimating);n.__isAnimating=false;n.__interruptedAnimation=true}var r,i;var s=e.length===1;if(s){r=e[0].pageX;i=e[0].pageY}else{r=Math.abs(e[0].pageX+e[1].pageX)/2;i=Math.abs(e[0].pageY+e[1].pageY)/2}n.__initialTouchLeft=r;n.__initialTouchTop=i;n.__zoomLevelStart=n.__zoomLevel;n.__lastTouchLeft=r;n.__lastTouchTop=i;n.__lastTouchMove=t;n.__lastScale=1;n.__enableScrollX=!s&&n.options.scrollingX;n.__enableScrollY=!s&&n.options.scrollingY;n.__isTracking=true;n.__didDecelerationComplete=false;n.__isDragging=!s;n.__isSingleTouch=s;n.__positions=[]},doTouchMove:function(e,t,n){if(e.length==null){throw new Error("Invalid touch list: "+e)}if(t instanceof Date){t=t.valueOf()}if(typeof t!=="number"){throw new Error("Invalid timestamp value: "+t)}var r=this;if(!r.__isTracking){return}var i,s;if(e.length===2){i=Math.abs(e[0].pageX+e[1].pageX)/2;s=Math.abs(e[0].pageY+e[1].pageY)/2}else{i=e[0].pageX;s=e[0].pageY}var o=r.__positions;if(r.__isDragging){var u=i-r.__lastTouchLeft;var a=s-r.__lastTouchTop;var f=r.__scrollLeft;var l=r.__scrollTop;var c=r.__zoomLevel;if(n!=null&&r.options.zooming){var h=c;c=c/r.__lastScale*n;c=Math.max(Math.min(c,r.options.maxZoom),r.options.minZoom);if(h!==c){var p=i-r.__clientLeft;var d=s-r.__clientTop;f=(p+f)*c/h-p;l=(d+l)*c/h-d;r.__computeScrollMax(c)}}if(r.__enableScrollX){f-=u*this.options.speedMultiplier;var v=r.__maxScrollLeft;if(f>v||f<0){if(r.options.bouncing){f+=u/2*this.options.speedMultiplier}else if(f>v){f=v}else{f=0}}}if(r.__enableScrollY){l-=a*this.options.speedMultiplier;var m=r.__maxScrollTop;if(l>m||l<0){if(r.options.bouncing){l+=a/2*this.options.speedMultiplier;if(!r.__enableScrollX&&r.__refreshHeight!=null){if(!r.__refreshActive&&l<=-r.__refreshHeight){r.__refreshActive=true;if(r.__refreshActivate){r.__refreshActivate()}}else if(r.__refreshActive&&l>-r.__refreshHeight){r.__refreshActive=false;if(r.__refreshDeactivate){r.__refreshDeactivate()}}}}else if(l>m){l=m}else{l=0}}}if(o.length>60){o.splice(0,30)}o.push(f,l,t);r.__publish(f,l,c)}else{var g=r.options.locking?3:0;var y=5;var b=Math.abs(i-r.__initialTouchLeft);var w=Math.abs(s-r.__initialTouchTop);r.__enableScrollX=r.options.scrollingX&&b>=g;r.__enableScrollY=r.options.scrollingY&&w>=g;o.push(r.__scrollLeft,r.__scrollTop,t);r.__isDragging=(r.__enableScrollX||r.__enableScrollY)&&(b>=y||w>=y);if(r.__isDragging){r.__interruptedAnimation=false}}r.__lastTouchLeft=i;r.__lastTouchTop=s;r.__lastTouchMove=t;r.__lastScale=n},doTouchEnd:function(e){if(e instanceof Date){e=e.valueOf()}if(typeof e!=="number"){throw new Error("Invalid timestamp value: "+e)}var t=this;if(!t.__isTracking){return}t.__isTracking=false;if(t.__isDragging){t.__isDragging=false;if(t.__isSingleTouch&&t.options.animating&&e-t.__lastTouchMove<=100){var n=t.__positions;var r=n.length-1;var i=r;for(var s=r;s>0&&n[s]>t.__lastTouchMove-100;s-=3){i=s}if(i!==r){var o=n[r]-n[i];var u=t.__scrollLeft-n[i-2];var a=t.__scrollTop-n[i-1];t.__decelerationVelocityX=u/o*(1e3/60);t.__decelerationVelocityY=a/o*(1e3/60);var f=t.options.paging||t.options.snapping?4:1;if(Math.abs(t.__decelerationVelocityX)>f||Math.abs(t.__decelerationVelocityY)>f){if(!t.__refreshActive){t.__startDeceleration(e)}}}else{t.options.scrollingComplete()}}else if(e-t.__lastTouchMove>100){t.options.scrollingComplete()}}if(!t.__isDecelerating){if(t.__refreshActive&&t.__refreshStart){t.__publish(t.__scrollLeft,-t.__refreshHeight,t.__zoomLevel,true);if(t.__refreshStart){t.__refreshStart()}}else{if(t.__interruptedAnimation||t.__isDragging){t.options.scrollingComplete()}t.scrollTo(t.__scrollLeft,t.__scrollTop,true,t.__zoomLevel);if(t.__refreshActive){t.__refreshActive=false;if(t.__refreshDeactivate){t.__refreshDeactivate()}}}}t.__positions.length=0},__publish:function(e,r,i,s){var o=this;var u=o.__isAnimating;if(u){core.effect.Animate.stop(u);o.__isAnimating=false}if(s&&o.options.animating){o.__scheduledLeft=e;o.__scheduledTop=r;o.__scheduledZoom=i;var a=o.__scrollLeft;var f=o.__scrollTop;var l=o.__zoomLevel;var c=e-a;var h=r-f;var p=i-l;var d=function(e,t,n){if(n){o.__scrollLeft=a+c*e;o.__scrollTop=f+h*e;o.__zoomLevel=l+p*e;if(o.__callback){o.__callback(o.__scrollLeft,o.__scrollTop,o.__zoomLevel)}}};var v=function(e){return o.__isAnimating===e};var m=function(e,t,n){if(t===o.__isAnimating){o.__isAnimating=false}if(o.__didDecelerationComplete||n){o.options.scrollingComplete()}if(o.options.zooming){o.__computeScrollMax()}};o.__isAnimating=core.effect.Animate.start(d,v,m,o.options.animationDuration,u?t:n)}else{o.__scheduledLeft=o.__scrollLeft=e;o.__scheduledTop=o.__scrollTop=r;o.__scheduledZoom=o.__zoomLevel=i;if(o.__callback){o.__callback(e,r,i)}if(o.options.zooming){o.__computeScrollMax()}}},__computeScrollMax:function(e){var t=this;if(e==null){e=t.__zoomLevel}t.__maxScrollLeft=Math.max(t.__contentWidth*e-t.__clientWidth,0);t.__maxScrollTop=Math.max(t.__contentHeight*e-t.__clientHeight,0)},__startDeceleration:function(e){var t=this;if(t.options.paging){var n=Math.max(Math.min(t.__scrollLeft,t.__maxScrollLeft),0);var r=Math.max(Math.min(t.__scrollTop,t.__maxScrollTop),0);var i=t.__clientWidth;var s=t.__clientHeight;t.__minDecelerationScrollLeft=Math.floor(n/i)*i;t.__minDecelerationScrollTop=Math.floor(r/s)*s;t.__maxDecelerationScrollLeft=Math.ceil(n/i)*i;t.__maxDecelerationScrollTop=Math.ceil(r/s)*s}else{t.__minDecelerationScrollLeft=0;t.__minDecelerationScrollTop=0;t.__maxDecelerationScrollLeft=t.__maxScrollLeft;t.__maxDecelerationScrollTop=t.__maxScrollTop}var o=function(e,n,r){t.__stepThroughDeceleration(r)};var u=t.options.snapping?4:.1;var a=function(){var e=Math.abs(t.__decelerationVelocityX)>=u||Math.abs(t.__decelerationVelocityY)>=u;if(!e){t.__didDecelerationComplete=true}return e};var f=function(e,n,r){t.__isDecelerating=false;if(t.__didDecelerationComplete){t.options.scrollingComplete()}t.scrollTo(t.__scrollLeft,t.__scrollTop,t.options.snapping)};t.__isDecelerating=core.effect.Animate.start(o,a,f)},__stepThroughDeceleration:function(e){var t=this;var n=t.__scrollLeft+t.__decelerationVelocityX;var r=t.__scrollTop+t.__decelerationVelocityY;if(!t.options.bouncing){var i=Math.max(Math.min(t.__maxDecelerationScrollLeft,n),t.__minDecelerationScrollLeft);if(i!==n){n=i;t.__decelerationVelocityX=0}var s=Math.max(Math.min(t.__maxDecelerationScrollTop,r),t.__minDecelerationScrollTop);if(s!==r){r=s;t.__decelerationVelocityY=0}}if(e){t.__publish(n,r,t.__zoomLevel)}else{t.__scrollLeft=n;t.__scrollTop=r}if(!t.options.paging){var o=.95;t.__decelerationVelocityX*=o;t.__decelerationVelocityY*=o}if(t.options.bouncing){var u=0;var a=0;var f=.03;var l=.08;if(n<t.__minDecelerationScrollLeft){u=t.__minDecelerationScrollLeft-n}else if(n>t.__maxDecelerationScrollLeft){u=t.__maxDecelerationScrollLeft-n}if(r<t.__minDecelerationScrollTop){a=t.__minDecelerationScrollTop-r}else if(r>t.__maxDecelerationScrollTop){a=t.__maxDecelerationScrollTop-r}if(u!==0){if(u*t.__decelerationVelocityX<=0){t.__decelerationVelocityX+=u*f}else{t.__decelerationVelocityX=u*l}}if(a!==0){if(a*t.__decelerationVelocityY<=0){t.__decelerationVelocityY+=a*f}else{t.__decelerationVelocityY=a*l}}}}};for(var i in r){Scroller.prototype[i]=r[i]}})();(function(e){var t=Date.now||function(){return+(new Date)};var n=60;var r=1e3;var i={};var s=1;if(!e.core){e.core={effect:{}}}else if(!core.effect){core.effect={}}core.effect.Animate={requestAnimationFrame:function(){var t=e.requestAnimationFrame||e.webkitRequestAnimationFrame||e.mozRequestAnimationFrame||e.oRequestAnimationFrame;var n=!!t;if(t&&!/requestAnimationFrame\(\)\s*\{\s*\[native code\]\s*\}/i.test(t.toString())){n=false}if(n){return function(e,n){t(e,n)}}var r=60;var i={};var s=0;var o=1;var u=null;var a=+(new Date);return function(e,t){var n=o++;i[n]=e;s++;if(u===null){u=setInterval(function(){var e=+(new Date);var t=i;i={};s=0;for(var n in t){if(t.hasOwnProperty(n)){t[n](e);a=e}}if(e-a>2500){clearInterval(u);u=null}},1e3/r)}return n}}(),stop:function(e){var t=i[e]!=null;if(t){i[e]=null}return t},isRunning:function(e){return i[e]!=null},start:function(e,o,u,a,f,l){var c=t();var h=c;var p=0;var d=0;var v=s++;if(!l){l=document.body}if(v%20===0){var m={};for(var g in i){m[g]=true}i=m}var y=function(s){var m=s!==true;var g=t();if(!i[v]||o&&!o(v)){i[v]=null;u&&u(n-d/((g-c)/r),v,false);return}if(m){var b=Math.round((g-h)/(r/n))-1;for(var w=0;w<Math.min(b,4);w++){y(true);d++}}if(a){p=(g-c)/a;if(p>1){p=1}}var E=f?f(p):p;if((e(E,g,m)===false||p===1)&&m){i[v]=null;u&&u(n-d/((g-c)/r),v,p===1||a==null)}else if(m){h=g;core.effect.Animate.requestAnimationFrame(y,l)}};i[v]=true;core.effect.Animate.requestAnimationFrame(y,l);return v}}})(this);